{
  description = "A quick create wizard to create and modify opinionated kustomize deployments.";

  inputs = {
    rust-overlay.url = "github:oxalica/rust-overlay";
    flake-utils.follows = "rust-overlay/flake-utils";
    nixpkgs.follows = "rust-overlay/nixpkgs";
  };

  outputs = inputs: with inputs;
    flake-utils.lib.eachDefaultSystem (system:
      let
        pkgs = nixpkgs.legacyPackages.${system};
        code = pkgs.callPackage ./. { inherit nixpkgs system rust-overlay; };
      in rec {
        packages = {
          kustomize-quick-create = code.kustomize-quick-create;
          all = pkgs.symlinkJoin {
            name = "all";
            paths = with code; [ kustomize-quick-create ];
          };
        default = packages.all;
        };
      }
    );
}
